program ListyCykliczne;

{Implementacja podstawowych operacji na listach cyklicznych}
{Materiay do wykadu z Technik Programowania na ZSI}
{Autor: Janusz Jabonowski}
{2004}

type
  TypDanych = string; {W listach bdziemy przechowywa napisy}

  TLista	   = ^TEltListy;
  TEltListy = record
               dane: TypDanych;
               nast: TLista;
              end;

procedure Ini(var l: TLista);
 {Inicjalizuje list na pust}
 begin
  l := nil;
 end; {Ini}

procedure WstawNaPocz(var l: TLista; dane: TypDanych);
 {Wstawia element na pocztek listy}
 var
  pom: TLista;
 begin
  {Tworz nowe pudeko}
  new(pom);
  pom^.dane := dane;
  {Doczam je na pocztek listy}
  if l <> nil
  then
   begin
    pom^.nast := l^.nast;
    l^.nast := pom;
   end
  else {l = nil}
   begin
    pom^.nast := pom; {Tworz ptelk}
    l := pom;
   end;
 end; {WstawNaPocz}

procedure WczytajListeOdwrotnie(var l:Tlista);
 {Wczytuje list element po elemencie od uytkownika. Uwaga:}
 {odwraca kolejno elementw.}
 var
  napis: string;
 begin
  {Na pocztku lista jest pusta}
  l := nil;
  napis := '';
  {Teraz po kolei dopisuj do niej nowe elementy}
  repeat
    write('Podaj kolejny napis (pusty koczy): ');
    readln(napis);
    if napis <> ''
    then
      WstawNaPocz(l, napis)
  until napis = '';
 end; {WczytajListOdwrotnie}

procedure PrzejdzListe(l: TLista);
 {Przechodzi ca list}
 var
  pom: TLista;
 begin
  if l <> nil
  then
   begin
    {Zwrmy uwag na niebezpieczestwo zaptlenia!}
    pom := l^.nast;
    repeat
      writeln(pom^.dane);  {Tu robi co z elementem listy pom^.dane}
      pom := pom^.nast;    {A tu przechodz do nastpnego elementu}
    until pom = l^.nast;
   end
 end; {PrzejdList}

function DlugoscListy(l: TLista): Integer;
 {Oblicza dugo listy l}
 var
  wyn: Integer;
  pom: TLista; {Biecy element listy}
 begin
  wyn := 0;
  if l <> nil
  then
   begin
    pom := l; {Zliczajc elementy listy mog zacz liczy od ostatniego}
    repeat
      pom := pom^.nast;
      wyn := wyn + 1;
    until pom = l;
   end;
  DlugoscListy := wyn
 end; {DlugoListy}

procedure UsunWszystkoZListy(var l: TLista);
 {Usuwa wszystkie elementy z listy}
 var
  pom: TLista; {Pomocnicza, do usuwania elementw listy}
 begin
  if l <> nil
  then
   begin
    while l <> l^.nast do
     begin
      pom := l^.nast;
      l^.nast := pom^.nast;
      dispose(pom);
     end;
    dispose(l); {Ostatni element listy}
    l := nil;
   end;
 end; {UsuWszystkoZListy}

procedure WstawNaKoniec(var l: TLista; dane: TypDanych);
 {Wstawia element na koniec listy.}
 var
  pom: TLista;
 begin
  {Tworz nowe pudeko}
  new(pom);
  pom^.dane := dane;
  {Doczam je na koniec listy}
  if l <> nil
  then
   begin
    pom^.nast := l^.nast;
    l^.nast := pom;
   end
  else {l = nil}
    pom^.nast := pom; {Tworz ptelk}
  l := pom;
 end; {WstawNaKoniec}

procedure WczytajListePoKolei(var l:Tlista);
 {Wczytuje list element po elemencie od uytkownika. Zachowuje kolejno}
 {wczytanych elementw.}
 var
  napis: string;
 begin
  {Na pocztku lista jest pusta}
  l := nil;
  napis := '';
  {Teraz po kolei dopisuj do niej nowe elementy}
  repeat
    write('Podaj kolejny napis (pusty koczy): ');
    readln(napis);
    if napis <> ''
    then
      WstawNaKoniec(l, napis)
  until napis = '';
 end; {WczytajListPoKolei}

procedure UsunPierwszy(var l: TLista);
 {Usuwa pierwszy element listy l. Jeli bya pusta to nic nie robi.}
 var
  pom: TLista; {Pomocniczy, do usuwania elementu z pamici}
 begin
  if l <> nil
  then
   begin
    pom := l^.nast;
    if pom = l
    then {To by ostatni element listy}
     l := nil
    else
     l^.nast := pom^.nast;
    dispose(pom);
   end;
 end; {UsuPierwszy}

function Szukaj(l: TLista; Co: TypDanych): Integer;
 {Szuka liczby Co na licie l. Jeli Co wystpuje na licie daje}
 {jako wynik pozycj pierwszego wystapienia Co na licie, wpp. daje 0.}
 var
  wyn: Integer; 
  Jest: Boolean; {Czy znalazem}
  Biez: Integer; {Bieca pozycja na licie}
  pom: TLista;   {Biecy element listy}
 begin
  Wyn := 0; {Pesymistycznie}
  Jest := false;
  Biez := 1;
  if l <> nil
  then
   begin
    pom := l^.nast;
    repeat
     if pom^.dane = Co
     then
      begin
       Jest := true;
       wyn := Biez;
      end
     else
      begin
       Biez := Biez + 1;
       pom := pom^.nast;
     end;
    until (pom = l^.nast) or Jest
   end;
  Szukaj := Wyn;
 end; {Szukaj}

 procedure UsunWskazany(var l: TLista; Wskazany: TypDanych);
  {Usuwa wszystkie wystpienia elementu Wskazany z listy l.}
  var
   Poprz, Biez: TLista;  {Poprzedni i biecy element na licie}
   pom: TLista;          {Pomocnicza, do usuwania elementu z listy}
  begin
   if l <> nil
   then
    begin
     Poprz := l;
     Biez := l^.nast;
     repeat
       if Biez^.dane = Wskazany
       then
        begin
         {Usuwam element Biez}
         pom := Biez;
         Poprz^.nast := Biez^.nast;

         if Biez = l
         then {Usuwam ostatni element listy, trzeba uaktualni l}
           if l^.nast = l
           then {To jest jednoczenie jedyny element listy}
            begin
             l := nil;
             Poprz := nil; {Na wszelki wypadek}
             Biez := nil;  {Na wszelki wypadek}
            end
           else {Ostatni ale nie jedyny element na licie}
            begin
             l := Poprz;
             Biez := Poprz^.nast;
            end
         else {Biez nie jest ostatnim elementem listy}
           Biez := Poprz^.nast;

         Dispose(pom);
        end
       else {Id dalej}
        begin
         Poprz := Biez;
         Biez := Biez^.nast;
        end
     {$B-}
     until (l=nil) or (Biez = l^.nast);
     {Kocz gdy wszystko usun z listy lub Bie znw bdzie pokazywa}
     {na pierwszy element listy}
    end
  end; {UsuWskazany}

begin {program gwny}
 {...}
end.
