program ListyZOpisem;

{Implementacja podstawowych operacji na listach z opisem}
{Materiay do wykadu z Technik Programowania na ZSI}
{Autor: Janusz Jabonowski}
{2004}

type
  TypDanych = string; {W listach bdziemy przechowywa napisy}

  TLista     = ^TEltListy;
  TEltListy = record
                      dane: TypDanych;
                      nast: TLista;
                    end;
  TListaO = record  {Typ listy z opisem}
                     pocz : TLista;
                     konc : TLista;
                     ile  : Integer;
                   end;

procedure Ini(var l: TListaO);
 {Inicjuje list na pust}
 begin
  with l do
   begin
    pocz := nil;
    konc := nil;
    ile := 0;
   end
 end; {Ini}

procedure WstawNaPocz(var l: TListaO; dane: TypDanych);
 {Dostawia element na pocztek listy}
 var
  pom: TLista;
 begin
  with l do
   begin
    {Tworz nowe pudeko}
    new(pom);
    pom^.dane := dane;
    pom^.nast := pocz;
    {Doczam je na pocztek listy}
    ile := ile + 1;
    if pocz <> nil
    then {Doczam do niepustej listy}
      pocz := pom
    else {pocz = nil, czyli lista bya pusta}
     begin
      pocz := pom;
      konc := pom;
     end;
   end; {with}
 end; {WstawNaPocz}

procedure WczytajListeOdwrotnie(var l:TListaO);
 {Wczytuje list element po elemencie od uytkownika. Uwaga:}
 {odwraca kolejno elementw.}
 var
  napis: string;
 begin
  {Na pocztku lista jest pusta}
   ini(l);
  napis := '';
  {Teraz po kolei dopisuj do niej nowe elementy}
  repeat
    write('Podaj kolejny napis (pusty koczy): ');
    readln(napis);
    if napis <> ''
    then
      WstawNaPocz(l, napis)
  until napis = '';
 end; {WczytajListOdwrotnie}

procedure PrzejdzListe(l: TListaO);
 {Przechodzi ca list i umieszcza jej kolejne elementy w komponencie}
 {ListBox}
 {Zwrmy uwag e l.pocz jest modyfikowane w treci tej procedury, ale nie}
 {powoduje to utraty dowizania do pocztku listy, bo l jest przekazywane przez}
 {warto.}
 begin
  with l do
   begin
    while pocz <> nil do
     begin
      writeln(pocz^.dane);  {Tu robi co z elementem listy}
      pocz := pocz^.nast;   {A tu przechodz do nastpnego elementu}
     end;
   end;
 end; {PrzejdList}

function DlugoscListy(l: TListaO): Integer;
 {Oblicza dugo listy l}
 begin
  DlugoscListy := l.ile; {W tej implementacji liczenie dugoci listy jest najprostsze}
 end; {DlugoListy}

procedure UsunWszystkoZListy(var l: TListaO);
 {Usuwa wszystkie elementy z listy}
 var
  pom: TLista; {Pomocnicza, do usuwania elementw listy}
 begin
  with l do
   begin
    while pocz <> nil do
     begin
      pom := pocz;
      pocz := pocz^.nast;
      dispose(pom);
     end;
    pocz := nil;
    konc := nil;
    ile := 0;
   end;
 end; {UsuWszystkoZListy}

procedure WstawNaKoniec(var l: TListaO; dane: TypDanych);
 {Dostawia element na koniec listy.}
 var
  pom: TLista;
 begin
  {Tworz nowe pudeko}
  new(pom);
  pom^.dane := dane;
  pom^.nast := nil;
  with l do
   begin
    ile := ile + 1;
    if konc <> nil
    then {Lista nie bya pusta}
     begin
      konc^.nast := pom;
      konc := pom;
     end
    else {Lista bya pusta}
     begin
      konc := pom;
      pocz := pom;
     end;
   end;
 end; {WstawNaKoniec}

procedure WczytajListePoKolei(var l:TlistaO);
 {Wczytuje list element po elemencie od uytkownika. Zachowuje kolejno}
 {wczytanych elementw.}
 var
  napis: string;
 begin
  {Na pocztku lista jest pusta}
   ini(l);
  napis := '';
  {Teraz po kolei dopisuj do niej nowe elementy}
  repeat
    write('Podaj kolejny napis (pusty koczy): ');
    readln(napis);
    if napis <> ''
    then
      WstawNaKoniec(l, napis)
  until napis = '';
 end; {WczytajListPoKolei}

procedure UsunPierwszy(var l: TListaO);
 {Usuwa pierwszy element listy l. Jeli bya pusta to nic nie robi.}
 var
  pom: TLista; {Pomocniczy, do usuwania elementu z pamici}
 begin
  with l do
   begin
    if pocz <> nil
    then
     begin
      pom := pocz;
      pocz := pocz^.nast;
      dispose(pom);
      ile := ile - 1;
      if ile = 0
      then
       konc := nil;
     end;
   end;
 end; {UsuPierwszy}

function Szukaj(l: TListaO; Co: TypDanych): Integer;
 {Szuka liczby Co na licie l. Jeli Co wystpuje na licie daje}
 {jako wynik pozycj pierwszego wystapienia Co na licie, wpp. daje 0.}
 {Uwaga: l.pocz jest zmieniane wewntrz tej funkcji, ale dziki temu, e}
 {       l jest przekazywane przez warto nie ma adnego znaczenia.}
 var
  wyn: Integer;
  Jest: Boolean; {Czy znalazem}
  Biez: Integer; {Bieca pozycja na licie}
 begin
  with l do
   begin
    Wyn := 0; {Pesymistycznie}
    Jest := false;
    Biez := 1;
    while (pocz <> nil) and not Jest do
     if pocz^.dane = Co
     then
      begin
       Jest := true;
       wyn := Biez;
      end
     else
      begin
       Biez := Biez + 1;
       pocz := pocz^.nast;
      end;
    Szukaj := Wyn;
   end;
 end; {Szukaj}

 procedure UsunWskazany(var l: TListaO; Wskazany: TypDanych);
  {Usuwa wszystkie wystpienia elementu Wskazany z listy l.}
  var
   Poprz, Biez: TLista;  {Poprzedni i biecy element na licie}
   pom: TLista; {Pomocnicza, do usuwania elementu z listy}
  begin
   with l do
    begin
     Poprz := nil;
     Biez := pocz;
     while Biez <> nil do
      begin
       if Biez^.dane = Wskazany
       then
        begin
         {Usuwam element Biez}
         ile := ile - 1;
         pom := Biez;
         if Poprz <> nil
         then {Usuwam kolejny (tj. nie pierwszy) element listy}
           Poprz^.nast := Biez^.nast
         else {Usuwam pierwszy element listy}
           pocz := Biez^.nast;
         if pom = konc
         then {Usuwam ostatni w kolejnoci element na licie}
           konc := Poprz;
         Biez := Biez^.nast; {Zwrmy uwag, e nie mona zamieni kolejnoci}
         dispose(pom);       {tych dwu instrukcji!}
        end
       else {Id dalej}
        begin
         Poprz := Biez;
         Biez := Biez^.nast;
        end;
      end;
    end;
  end; {UsuWskazany}

begin
 { ... }
end.
